#define ZLOGGER_VERSION 1.2
#define ZLOGGER_VERSION_STRING "1.2"

typedef struct struct_entry {
  char *class;
  regex_t instance;
  regex_t opcode;
  int negateinstance;
  int negateopcode;
  char *logfile;
  int logfilenoparse;
  int nolog;
  int logroll;
  int loglife;
  struct struct_entry *next;
} entry;

typedef struct struct_globalconfig {
  entry *entries;
  char *ticketfile;
  char *srvtab;
  char *kservice;
  int newtickets; /* in hours   */
  int newsubs;    /* in minutes */
  char hostname[MAXHOSTNAMELEN];
  char *cells;
} globalconfig;

extern int readconfig(char *filename, globalconfig *g);
extern void argserr(char *key, int line);
extern void keyerr(char *key, int line);
extern void regexerr(char *reg, int line);
extern char **atokenize(char *buffer, char *sep, int *i);
extern char *mystrdup(char *foo);
extern void downstr(char *foo);
extern void get_tickets_and_tokens(globalconfig *g);
extern int ksrvtgt(char *principal, char *instance, char *in_srvtab, int timeunits);
extern void getsubs(globalconfig *g);
extern void lognotice(globalconfig *g, ZNotice_t *notice);
extern void writelog(entry *ent, ZNotice_t *notice);
extern int is_weird (char *instance);
extern void turnoverlogs(globalconfig *g);
extern void initlogs(globalconfig *g);
extern void securefile(char *path);
